/*
 * @file
 * Javascript for showing and hiding dependent attributes.
 *
 * Retrieves the dependencies from the database using a callback and shows
 * and hides attributes depending upon the value selected for the attribute
 * they depend upon.
 */

(function ($) {

  Drupal.behaviors.uc_dropdown_attributes = {
    attach: function (context, settings) {
      // Retrieve the node id
      var nid = $('div.add-to-cart').find(':input[name="node_id"]').val();
      $('div.attributes').find('div.attribute').each( function(i,val) {
        var attributes = $(val).attr('class').split(' ');
        if (attributes[1] != undefined) {
          var aid = attributes[1].split('-')[1];
          $.get(Drupal.settings.basePath +
                'node/' + nid + '/view/dependencies/' + aid + '/callback',
                null, readAttribute);
        }
      });
    }
  };

  var readAttribute = function(response) {
    alert('Debug');
    if (response.status) {
      $('#edit-attributes-' + response.parent_aid).change(function() {
        value=$('#edit-attributes-' + response.parent_aid).val();
        if (value != undefined) {
          if (response.parent_values[value] == undefined) {
            $('.attribute-' + response.aid).slideUp();
            $('#edit-attributes-' + response.aid).val('');
            $('#edit-attributes-' + response.aid).trigger('change');
          } 
          else {
            if (response.parent_values[value] != undefined) {
              $('.attribute-' + response.aid).slideDown();
            }
            else {
              $('.attribute-' + response.aid).slideUp();
              $('#edit-attributes-' + response.aid).val('');
              $('#edit-attributes-' + response.aid).trigger('change');
            }
          }
        }
      });
      $('#edit-attributes-' + response.parent_aid + '-1').change(function() {
        value=$('#edit-attributes-' + response.parent_aid + '-1').val();
        if (value != undefined) {
          if (response.parent_values[value] == undefined) {
            $('.attribute-' + response.aid + '-1').slideUp();
            $('#edit-attributes-' + response.aid + '-1').val('');
            $('#edit-attributes-' + response.aid + '-1').trigger('change');
          } else {
            if (response.parent_values[value] != undefined) {
              $('.attribute-' + response.aid + '-1').slideDown();
            }
            else {
              $('.attribute-' + response.aid + '-1').slideUp();
              $('#edit-attributes-' + response.aid + '-1').val('');
              $('#edit-attributes-' + response.aid + '-1').trigger('change');
            }
          }
        }
      });
      if (response.required == 1) {
        $('.attribute-' + response.aid).find('label').replaceWith('<label>' + $('.attribute-' + response.aid).find('label').text() + '<span class="form-required" title="' + Drupal.t('This field is required.') + '">*</span></label>');
        $('.attribute-' + response.aid + '-1').find('label').replaceWith('<label>' +$('.attribute-' + response.aid + '-1').find('label').text() + '<span class="form-required" title="' + Drupal.t('This field is required.') + '">*</span></label>');
      }
      value = $('#edit-attributes-' + response.parent_aid).val();
      if (value != undefined) {
        if (response.parent_values[value] == undefined) {
          $('.attribute-' + response.aid).slideUp();
        } else {
          if (response.parent_values[value] != undefined) {
            $('.attribute-' + response.aid).slideDown();
          }
          else {
            $('.attribute-' + response.aid).slideUp();
          }
        }
      }
      value = $('#edit-attributes-' + response.parent_aid + '-1').val();
      if (value != undefined) {
        if (response.parent_values[value] == undefined) {
          $('.attribute-' + response.aid + '-1').slideUp();
        } else {
          if (response.parent_values[value] != undefined) {
            $('.attributes-' + response.aid + '-1').slideDown();
          }
          else {
            $('.attributes-' + response.aid + '-1').slideUp();
          }
        }
      }
    }
  }
})(jQuery);
